<?php
// +-----------------------------------------------------------------------+
// | Piwigo - a PHP based picture gallery                                  |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2008      Pavel Budka                http://pbudka.co.cc |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+
function theme_switch()
{
  global $user, $template, $conf, $lang;
  if (!defined('PHPWG_ROOT_PATH')) { die('Hacking attempt!'); }
  $same = $user['template'].'/'.$user['theme'];
  if ( isset( $_GET['theme']) and isset( $_GET['template']) )
  {
    if ( !empty($_GET['theme']) and !empty($_GET['template']) and
      file_exists( PHPWG_ROOT_PATH.'template/'.$_GET['template'].'/theme/'.$_GET['theme']) )
    {
      if (is_a_guest() or is_generic())
      {
        setcookie( 'pwg_theme_switch', $_GET['theme'],
          time()+60*60*24*30, cookie_path() );
        setcookie( 'pwg_template_switch', $_GET['template'],
          time()+60*60*24*30, cookie_path() );
      }
      else
      {
        $query = 'UPDATE '.USER_INFOS_TABLE.'
        SET template = \''.$_GET['template'].'/'.$_GET['theme'].'\'
        WHERE user_id = '.$user['id'].'
        ;';
        pwg_query($query);
      }
      $user['theme'] = $_GET['theme'];
      $user['template'] = $_GET['template'];
    }
  }
  else
  // Users have $user['template']/$user['theme'] 
  // Guest or generic members will use their cookied $user['template']/$user['theme'] !
  if ((is_a_guest() or is_generic())
    and isset( $_COOKIE['pwg_theme_switch'] )
    and isset( $_COOKIE['pwg_template_switch'] ) )
  {
    $user['template'] = $_COOKIE['pwg_template_switch'];
    $user['theme'] = $_COOKIE['pwg_theme_switch'];
  }
}

function theme_icons()
// Lets user choose from icons 
// Only themes which have gif icon provided in icons plugin directory will be provided to users.
// Gif file name must be the same as theme's name and must be stored in sub directory named according to template's name.  
{
  global $user, $template, $lang;
  
  $available_theme = get_pwg_themes();
  foreach ( $available_theme as $code )
  {
    list($temp, $theme) = split('/',$code);
    $qlc_url = add_url_params( make_index_url(), array( 'template' => $temp, 'theme' => $theme  ) );
    
    
    if (isset($lang['theme']))
      $qlc_alt = $lang['theme'].': '.ucwords( $code );
    else
      $qlc_alt = ucwords( $code );
    $qlc_title =  $qlc_alt;
    $qlc_img =  'plugins/theme_switch/icons/' . $code . '.gif';

    if ( $code !== $user['template'].'/'.$user['theme'] and file_exists(PHPWG_ROOT_PATH.$qlc_img) )
    {
      $template->concat( 'PLUGIN_INDEX_ACTIONS',
        '<li><a href="' . $qlc_url . '" ><img src="' . get_root_url().$qlc_img . '" alt="'
        . $qlc_alt . '" title="'
        . $qlc_title . '" style="border: 1px solid #000000; '
        . ' margin: 0px 2px;" /></a></li>');
    }
  }
}

function theme_select()
// Lets user choose using select control 
// All available themes will be provided to users. 
{
  global $user, $template, $lang;
  
  $available_theme = get_pwg_themes();
  $options='<li><span class="property">
   <label for="template">'.$lang['theme'].'</label>
  </span>
  <select name="template" onchange="javasript:window.location=this.value">';
  foreach ( $available_theme as $code )
  {
    list($temp, $theme) = split('/',$code);
    $qlc_url = add_url_params( make_index_url(), array( 'template' => $temp, 'theme' => $theme  ) );
    
    if ( $code == $user['template'].'/'.$user['theme'] )
      $tmp='" selected="selected">';
    else
      $tmp='">';
    $options=$options.'
    <option label="'.$code.'" value="'.$qlc_url.$tmp.$code.'</option>';
  }
  $options=$options.'
  </select></li>';
  $template->concat( 'PLUGIN_INDEX_ACTIONS',$options);
}
?>
